If we're using built-in *printf functions, then provide prototypes.
[rsync/rsync.git] / runtests.sh
CommitLineData
e7d29902
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# This program is free software; you can redistribute it and/or modify
6# it under the terms of the GNU Lesser General Public License version
7# 2.1 as published by the Free Software Foundation.
8#
9# This program is distributed in the hope that it will be useful, but
10# WITHOUT ANY WARRANTY; without even the implied warranty of
11# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
12# Lesser General Public License for more details.
13#
14# You should have received a copy of the GNU Lesser General Public
15# License along with this program; if not, write to the Free Software
16# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
17
18
19# rsync top-level test script -- this invokes all the other more
20# detailed tests in order. This script can either be called by `make
21# check' or `make installcheck'. `check' runs against the copies of
22# the program and other files in the build directory, and
23# `installcheck' against the installed copy of the program.
24
25# In either case we need to also be able to find the source directory,
26# since we read test scripts and possibly other information from
27# there.
28
29# Whenever possible, informational messages are written to stdout and
30# error messages to stderr. They're separated out by the build farm
31# display scripts.
32
33# According to the GNU autoconf manual, the only valid place to set up
34# directory locations is through Make, since users are allowed to (try
35# to) change their mind on the Make command line. So, Make has to
36# pass in all the values we need.
37
38# For other configured settings we read ./config.sh, which tells us
39# about shell commands on this machine and similar things.
40
41# rsync_bin gives the location of the rsync binary. This is either
42# builddir/rsync if we're testing an uninstalled copy, or
43# install_prefix/bin/rsync if we're testing an installed copy. On the
44# build farm rsync will be installed, but into a scratch /usr.
45
46# srcdir gives the location of the source tree, which lets us find the
47# build scripts. At the moment we assume we are invoked from the
48# source directory.
49
50# This script must be invoked from the build directory.
51
52# A scratch directory, 'testtmp', is created in the build directory to
53# hold working files.
54
3a4c683f
MP
55# This script also uses the $loglevel environment variable. 1 is the
56# default value, and 10 the most verbose. You can set this from the
57# Make command line. It's also set by the build farm to give more
58# detail for failing builds.
59
60
61# NOTES FOR TEST CASES:
62
63# Each test case runs in its own shell.
e7d29902 64
12b9c840 65# Exit codes from tests:
e7d29902
MP
66
67# 1 tests failed
68# 2 error in starting tests
3a4c683f
MP
69# 77 this test skipped (random value unlikely to happen by chance, same as
70# automake)
71
12b9c840
MP
72# HOWEVER, the overall exit code to the farm is different: we return
73# the *number of tests that failed*, so that it will show up nicely in
74# the overall summary.
75
3a4c683f
MP
76# rsync.fns contains some general setup functions and definitions.
77
78
79# NOTES ON PORTABILITY:
80
81# Both this script and the Makefile have to be pretty conservative
82# about which Unix features they use.
83
84# We cannot count on Make exporting variables to commands, unless
85# they're explicitly given on the command line.
86
87# Also, we can't count on 'cp -a' or 'mkdir -p', although they're
88# pretty handy.
89
d286ee98
MP
90# I think some of the GNU documentation suggests that we shouldn't
91# rely on shell functions. However, the Bash manual seems to say that
92# they're in POSIX 1003.2, and since the build farm relies on them
93# they're probably working on most machines we really care about.
e7d29902
MP
94
95
96set -e
97
98. "./shconfig"
99
3a4c683f
MP
100RUNSHFLAGS='-e'
101
102if [ -n "$loglevel" ] && [ "$loglevel" -gt 8 ]
103then
42e66aa2
MP
104 if set -x
105 then
106 # If it doesn't work the first time, don't keep trying.
107 RUNSHFLAGS="$RUNSHFLAGS -x"
108 fi
3a4c683f 109fi
e7d29902
MP
110
111echo "============================================================"
112echo "$0 running in `pwd`"
113echo " rsync_bin=$rsync_bin"
114echo " srcdir=$srcdir"
115
5cb1f5c7 116if test ! -f $rsync_bin
e7d29902
MP
117then
118 echo "rsync_bin $rsync_bin is not a file" >&2
119 exit 2
120fi
121
5cb1f5c7 122if test ! -d $srcdir
e7d29902
MP
123then
124 echo "srcdir $srcdir is not a directory" >&2
125 exit 2
126fi
127
78ffe478 128RSYNC="$rsync_bin"
e7d29902 129
78ffe478 130export rsync_bin RSYNC
e7d29902
MP
131
132skipped=0
133missing=0
134passed=0
135failed=0
136
137scratchdir=./testtmp
138[ -d "$scratchdir" ] && rm -r "$scratchdir"
139mkdir "$scratchdir"
78ffe478 140scratchdir=`cd $scratchdir && pwd`
e7d29902 141echo " scratchdir=$scratchdir"
78ffe478 142
e7d29902
MP
143suitedir="$srcdir/testsuite"
144
3a4c683f
MP
145export scratchdir suitedir
146
882582b3 147for testscript in $suitedir/*.test
e7d29902 148do
882582b3 149 testbase=`echo $testscript | sed 's!.*/!!'`
e7d29902 150
863dff51 151 echo "----- $testbase starting"
e7d29902 152
3a4c683f 153 if sh $RUNSHFLAGS "$testscript"
e7d29902
MP
154 then
155 echo "----- $testbase completed succesfully"
156 passed=`expr $passed + 1`
3a4c683f
MP
157 else
158 case $? in
159 77)
160 echo "----- $testbase skipped"
161 skipped=`expr $skipped + 1`
162 ;;
163 *)
164 echo "----- $testbase failed!"
165 failed=`expr $failed + 1`
320989b0
MP
166 if [ "x$nopersist" = "xyes" ]
167 then
168 exit 1
169 fi
3a4c683f
MP
170 esac
171 fi
e7d29902
MP
172done
173
174echo '------------------------------------------------------------'
175echo "----- overall results:"
176echo " $passed passed"
177echo " $failed failed"
178echo " $skipped skipped"
179echo " $missing missing"
180echo '------------------------------------------------------------'
181
12b9c840 182exit `expr $failed + $missing`